  '=============================================================================|
  ' PicoRocks in Space - Teaser
  '
  ' written by Vegipete, Jan 2024
  ' Ported from CMM2 (somewhat)
  '
  ' needs:
  ' OPTION CPUSPEED 252000 (KHz)
  
  '=============================================================================
  ' Versions
  ' rocks1      'adapt VegiPete version to 640x80, copy some from CMM2 version
  ' rocks2      'fly the ship
  ' rocks3      'fire gun, detect asteroid hit
  ' rocks4      'hit asteroids, split when hit, clear keyboard buffer
  ' rocks5_MH   'MartinH changes, Fleet shown, respawn
    
  
  
  Option DEFAULT INTEGER
  Option LCDPANEL NOCONSOLE
  option angle degrees
  mode 1 '@Volhout MODE 2
  cls 0
  
  const MAXROCKS = 50
  dim float rock(MAXROCKS,7) ' 50 rocks: scale,angle,x,y,vx,vy,a,da
  dim trock (MAXROCKS)  ' type of rock
  math set 0, rock()    ' erase them all to start
  math set 0,trock()
  dim float v(1)        ' for math
  dim bult(5,3)         ' 6 bullets
  math set 0,bult()     ' no bullets flying around
  
  ' rock vector shapes
  ' Note: any resemblance to a country is purely coincidental
  dim r1x(14)=( 0, 3, 4, 3, 5, 4, 1,-2,-4,-5,-3,-5,-3,-2, 0)
  dim r1y(14)=( 5, 4, 3, 1, 0,-4,-5,-4,-4,-1,-1, 2, 3, 5, 5)
  dim r2x(14)=( 0,-2,-3,-4,-5,-4,-4,-3,-1, 4, 4, 5, 4, 2, 0)
  dim r2y(14)=(-6,-4,-3,-4,-1, 2, 3, 3, 5, 3, 1, 0,-3,-4,-6)
  dim r3x(14)=( 1,-2,-2,-4,-4,-5,-5,-3,-2, 0, 4, 3, 5, 3, 1)
  dim r3y(14)=(-4,-5,-3,-4,-2, 0, 3, 4, 3, 5, 3, 2, 1,-5,-4)
  dim r4x(14)=( 0,-2,-4,-4,-5,-3,-1, 2, 1, 3, 5, 3, 4, 3, 0)
  dim r4y(14)=(-5,-4,-4,-1, 1, 4, 5, 5, 3, 4, 1,-2,-3,-4,-5)
  
  ' player ship and exhaust flame shapes @Volhout *2
  dim shpx(4)=(0,-6,0,6,0)
  dim shpy(4)=(-10,10,6,10,-10)
  dim flmx(4)=(0,-2,0,2,0)
  dim flmy(4)=(8,10,14,10,8)
  
  FRAMEBUFFER Create   ' hidden layer to draw scene
  FRAMEBUFFER Write F : CLS
  
  dim float pv,px,py,pvx,pvy
  
  ph = 0 : pv = 0
  px = MM.HRES/2-6 : pvx = 0
  py = MM.VRES/2-6 : pvy = 0
  smash=0:newrun=0'1
  fire=0        '@Volhout copy from CMM2
  bspd=3        'bullet speed
  ships=5       'to start with
  timeout=3000  'respawn time out
  
  'copied from CMM2 sound
  play modfile "RISsound.mod"
  
  ' create 10 random rocks
  k = 1
  for i = 1 to 8'10
    trock(i)  = 1 + (k and 3) ' rock type (0=doesn't exist)
    rock(i,0) = 2 + int(rnd*6)' rock size @Volhout *2
    do  'initial place rocks 100 pix away from ship
      rock(i,2) = rnd*MM.HRES   ' x location
      rock(i,3) = rnd*MM.VRES   ' y location
    loop while ((rock(i,2)-MM.HRES/2)^2 + (rock(i,3)-MM.VRES/2)^2)<100*100
    rock(i,4) = 1-rnd*2   ' x velocity
    rock(i,5) = 1-rnd*2   ' y velocity
    rock(i,6) = rnd*360   ' starting angle
    rock(i,7) = 3-rnd*6   ' rotation speed
    inc k
  next
  
  mot = timer 'motor on timer
  
  do
    tm=timer
    
    'extract last key from key buffer
    do
      k=e:e=asc(inkey$)
    loop until e=0
    
    if k then
      burn = 0
      select case k
        Case 128  ' up
          inc pvx, sin(ph)/2
          inc pvy,-cos(ph)/2
          Play modsample 9,2'@Martin
          mot = timer + 200   ' keep flame visible for a while
        Case 130  ' left
          inc ph,-5
          if ph < 0 then ph = 355
        Case 131  ' right
          inc ph,5
          if ph > 355 then ph = 0
        case 32 'space for fire '102 'f'for fire
          fire=1:DrawFire
          Play modsample 3,1'@Martin
          'print "fire"
        case 27
          print : end
      end select
    endif
    
    Inc px,pvx-(MM.HRes+10)*(px > MM.HRes)+(MM.HRes+10)*(px<5)'@Martin
    'inc px,pvx
    'if px > MM.HRES then inc px, -(MM.HRES+10)
    'if px < 5 then inc px, MM.HRES+10
    
    Inc py,pvy-(MM.VRes+10)*(py > MM.VRes)+(MM.VRes+10)*(py<0)'@Martin
    'inc py,pvy
    'if py > MM.VRES then inc py, -(MM.VRES+10)
    'if py < 0 then inc py, MM.VRES+10
    
    ' velocity decays away slowly
    pvx = pvx * .99 '@Volhout .995
    pvy = pvy * .99 '@Volhout .995
    
    ' move rocks
    for i = 0 to MAXROCKS
      if trock(i) then   ' rock exists
        
        'move rocks and keep in window
        inc rock(i,2),rock(i,4)
        rock(i,2)=(rock(i,2)+mm.hres) mod mm.hres 'original
        'Inc rock(i,2),-MM.HRes*(rock(i,2)>MM.HRes)+MM.HRes*(rock(i,2)<0)'@Martin
        inc rock(i,3),rock(i,5)
        rock(i,3)=(rock(i,3)+mm.vres) mod mm.Vres ' original
        'Inc rock(i,3),-MM.VRes*(rock(i,3)>MM.VRes)+MM.VRes*(rock(i,3)<0)'@Martin
        
        'move bullets and check if something is hit
        for j = 0 to 5
          ' test for player bullet hitting asteroid
          if bult(j,0) then ' does this bullet exist?
            
            'move it, when off-screen then skip bullet
            inc bult(j,1),bspd*sin(bult(j,3))
            if bult(j,1)>MM.HRES or bult(j,1)<0 then bult(j,0)=0
            inc bult(j,2),-bspd*cos(bult(j,3))
            if bult(j,2)>MM.VRES or bult(j,2)<0 then bult(j,0)=0
            
            'check for hit
            v(1) = bult(j,1) - rock(i,2) '- rock(i,0)   'coordinate compare
            v(0) = bult(j,2) - rock(i,3) '- rock(i,0)   'y coordinate compare
            if math(magnitude v()) < 5*rock(i,0) then
              bult(j,0) = 0   ' end of bullet
              AstHit(i,j)
              continue for
            endif
          endif
        next
        '
        '' test for ufo bullet hitting asteroid
        'if bufo(j,0) then ' does this bullet exist?
        'v(1) = bufo(j,1) - ast(i,1) - asiz(an)
        'if v(1) > 1 + asiz(an) then continue for  ' early exit because gap is large
        'v(2) = bufo(j,2) - ast(i,2) - asiz(an)
        'if math(magnitude v()) < 1 + asiz(an) then
        'bufo(j,0) = 0   ' end of bullet
        'buct = buct - 1
        'AstHit(i,0)
        'continue for
        'endif
        'endif
        'next j
        '
        if (smash = 0) and (newrun = 0) then
          ' test for asteroid hit player ship
          v(0) = px - rock(i,2) '@Volhout
          v(1) = py - rock(i,3) '@Volhout
          if math(magnitude v()) < 10 + 5*rock(i,0) then
            print "hit" 'debug
            smash = 1
            ships=max(0,ships-1)
            'sprd = 5    ' start the debris field
            play modsample 6,4              ' player explosion
            thit=timer                      ' for respawn delay
            'new start location = centre
            px = MM.HRES/2-6 : pvx = 0
            py = MM.VRES/2-6 : pvy = 0
            AstHit(i,0) 'damage to asteroid also
            continue for
          endif
        endif
        
        '' test for asteroid hit ufo
        'if ufo(0) = 2 then    ' large ufo
        'v(1) = ufo(1) + 24 - ast(i,1) - asiz(an)
        'v(2) = ufo(2) + 12 - ast(i,2) - asiz(an)
        'if math(magnitude v()) < 17 + asiz(an) then
        'ufo(0) = 0 : nufo = 120   ' ufo death by asteroid
        'if ast(i,0) < 9 then NewDustCloud(ufo(1) + 24, ufo(2) + 12)
        'AstHit(i,0)
        'continue for
        'endif
        'elseif ufo(0) = 1 then  ' small ufo
        'v(1) = ufo(1) + 12 - ast(i,1) - asiz(an)
        'v(2) = ufo(2) +  6 - ast(i,2) - asiz(an)
        'if math(magnitude v()) < 10 + asiz(an) then
        'ufo(0) = 0 : nufo = 120    ' ufo death by asteroid
        'if ast(i,0) < 9 then NewDustCloud(ufo(1) + 12, ufo(2) + 6)
        'AstHit(i,0)
        'continue for
        'endif
        'endif
        
      endif
    next i
    
    'check win
    if math(sum trock())=0 then math set 0,bult()
    
    cls
    DrawShip
    DrawRocks
    DrawBullet
    DrawFleet
    text 0,0,str$(timer-tm,3,0) '@Volhout game loop time in ms
    FRAMEBUFFER copy F,N,B
    
  loop
  
  
sub AstHit(n,m)
  local i
  print "astroid ";n;" hit"
  Play modsample 6,3'@Martin
  
  'handle bullet
  bult(m,0)=0 'bullet does not fly any further
  
  'handle rock
  if rock(n,0)<3 then
  
    trock(n)=0  'remove from game play
    
  else
  
    'split the asteroid in 2 equal pieces half the size
    for i = 0 to MAXROCKS    'find second free slot
      if trock(i)=0 then exit for
    next
    
    'rock n modify, and rock i is the new ones
    trock(i)=trock(n)                                  'same type of asteroid
    rock(i,0)=max(rock(n,0)-2,2):rock(n,0)=rock(i,0)   'both half size
    rock(i,2) = rock(n,2)   ' x location
    rock(i,3) = rock(n,3)   ' y location
    rock(i,4) = cos(bult(m,3)):rock(n,4) = -cos(bult(m,3)) ' x velocity
    rock(i,5) = sin(bult(m,3)):rock(n,5) = -sin(bult(m,3)) ' y velocity
    rock(i,6) = rnd*360     ' starting angle random
    rock(i,7) = rock(n,7)   ' rotation speed
    
  end if
end sub
  
sub DrawBullet
  local i
  for i=0 to 5
    if bult(i,0) then pixel bult(i,1),bult(i,2)
  next
end sub
  
sub DrawShip
  local x(4),y(4)
  if smash=1 then
    if timer-thit>timeout then smash=0  'you can fly again
  else
    'off = (mot > timer) * 6624
    'this is the ship
    math scale shpx(),1,x()
    math scale shpy(),1,y()
    math v_rotate 0,0,ph,x(),y(),x(),y()
    math add x(),px,x()  ' position ship
    math add y(),py,y()
    polygon 5,x(),y()
    'this is the exhaust flame
    if mot > timer then
      math scale flmx(),1,x()
      math scale flmy(),1,y()
      math v_rotate 0,0,ph,x(),y(),x(),y()
      math add x(),px,x()  ' position rocket flame
      math add y(),py,y()
      polygon 5,x(),y()
    endif
  end if
end sub
  
sub DrawFleet
  local x(4),y(4),i,textx=30,texty=30,textw=16
  math add shpx(),textx,x()
  math add shpy(),texty,y()
  for i=1 to ships,x(),y()
    polygon 5,x(),y()
    math add x(),textw,x()
  next
end sub
  
  ' Go through the list of rocks and draw any that exist
sub DrawRocks
  local i
  local x(14),y(14)
  
  for i = 0 to MAXROCKS
    if trock(i) then   ' rock exists
      inc rock(i,6),rock(i,7) ' spin rock
      if rock(i,6) > 360 then inc rock(i,6),-360
      if rock(i,6) < 0 then inc rock(i,6),360
      
      select case trock(i) ' what shape of rock is it?
        case 1
          math scale r1x(),rock(i,0),x()
          math scale r1y(),rock(i,0),y()
        case 2
          math scale r2x(),rock(i,0),x()
          math scale r2y(),rock(i,0),y()
        case 3
          math scale r3x(),rock(i,0),x()
          math scale r3y(),rock(i,0),y()
        case 4
          math scale r4x(),rock(i,0),x()
          math scale r4y(),rock(i,0),y()
      end select
      math v_rotate 0,0,rock(i,6),x(),y(),x(),y()
      math add x(),rock(i,2),x()  ' position rock
      math add y(),rock(i,3),y()
      polygon 15,x(),y()
    endif
  next i
end sub
  
sub DrawFire
  local i
  if fire then
    for i=0 to 5
      if bult(i,0)=0 then
        bult(i,0)=1:bult(i,1)=px:bult(i,2)=py:bult(i,3)=ph
        fire=0:exit for
      end if
    next
  end if
end sub
